#include "include/vdr/plugin.h"
#include "include/vdr/interface.h"
#include "include/vdr/status.h"
#include "include/vdr/skins.h"
#include "include/vdr/channels.h"
#include "include/vdr/config.h"

cPlugin::cPlugin() {}
cPlugin::~cPlugin() {}
const char* cPlugin::CommandLineHelp() {return NULL;}
bool cPlugin::ProcessArgs(int count, char**args) {return true;}
bool cPlugin::Initialize(void) {return true;}
bool cPlugin::Start(void) {return true;}
void cPlugin::Housekeeping(void) {}
const char *cPlugin::MainMenuEntry(void) {return NULL;}
cOsdObject *cPlugin::MainMenuAction(void) {return NULL;}
cMenuSetupPage *cPlugin::SetupMenu(void) {return NULL;}
bool cPlugin::SetupParse(const char *Name, const char *Value) {return true;}
void cPlugin::RegisterI18n(const tI18nPhrase * const Phrases){}
void cPlugin::SetupStore(const char *Name, const char *Value) {}
void cPlugin::SetupStore(const char *Name, int Value) {}
bool cInterface::Confirm(char const*, int, bool)  {return true;}

cSkins::cSkins() {}
cSkins::~cSkins() {}
eKeys cSkins::Message(eMessageType, char const*, int)  {}

cChannels::cChannels() {
}

void cStatus::MsgOsdCurrentItem(char const* c) {}

cCaDefinitions CaDefinitions;

const cCaDefinition *cCaDefinitions::Get(int Number)
{
  cCaDefinition *p = First();
  while (p) {
        if (p->Number() == Number)
           return p;
        p = (cCaDefinition *)p->Next();
        }
  return NULL;
}

cSkins Skins;
cChannels Channels;
cInterface *Interface;

int cCiHandler::GetCaFd() {return -1;}
cCaDefinition::cCaDefinition()  {}
cCaDefinition::~cCaDefinition() {}
bool cCaDefinition::Parse(const char *s) {return true;}
//const cCaDefinition *caDefinitions::Get(int Number) {return NULL;}

cString cSource::ToString(int Code)
{
  char buffer[16];
  char *q = buffer;
  switch (Code & st_Mask) {
    case stCable: *q++ = 'C'; break;
    case stSat:   *q++ = 'S';
                  {
                    int pos = Code & ~st_Mask;
                    q += snprintf(q, sizeof(buffer) - 2, "%u.%u", (pos & ~st_Neg) / 10, (pos & ~st_Neg) % 10); // can't simply use "%g" here since the silly 'locale' messes up the decimal point
                    *q++ = (Code & st_Neg) ? 'E' : 'W';
                  }
                  break;
    case stTerr:  *q++ = 'T'; break;
    default:      *q++ = Code + '0'; // backward compatibility
    }
  *q = 0;
  return buffer;
}

int cSource::FromString(const char *s)
{
  int type = stNone;
  switch (toupper(*s)) {
    case 'C': type = stCable; break;
    case 'S': type = stSat;   break;
    case 'T': type = stTerr;  break;
    case '0' ... '9': type = *s - '0'; break; // backward compatibility
    default: esyslog("ERROR: unknown source key '%c'", *s);
             return stNone;
    }
  int code = type;
  if (type == stSat) {
     int pos = 0;
     bool dot = false;
     bool neg = false;
     while (*++s) {
           switch (toupper(*s)) {
             case '0' ... '9': pos *= 10;
                               pos += *s - '0';
                               break;
             case '.':         dot = true;
                               break;
             case 'E':         neg = true; // fall through to 'W'
             case 'W':         if (!dot)
                                  pos *= 10;
                               break;
             default: esyslog("ERROR: unknown source character '%c'", *s);
                      return stNone;
             }
           }
     if (neg)
        pos |= st_Neg;
     code |= pos;
     }
  return code;
}
